--[[
	Description: This plugin is part of the "Titan Panel [Currencies] Multi" addon. It shows your amount of Apexis Crystal.
	Site: http://www.curse.com/addons/wow/titan-panel-currencies-multi
	Author: Canettieri
	Special Thanks to Eliote, pas06.
--]]

local _, L = ...;
local ACE = LibStub("AceLocale-3.0"):GetLocale("Titan", true)
local version = L["addonversion"]
local ID = "AC"
local elap, currencyCount = 0, 0.0
local f = CreateFrame("Button", "TitanPanelACButton", CreateFrame("Frame", nil, UIParent), "TitanPanelComboTemplate")
f:SetFrameStrata("FULLSCREEN")
f:SetScript("OnEvent", function(this, event, ...) this[event](this, ...) end)
f:RegisterEvent("ADDON_LOADED")

function f:ADDON_LOADED(a1)
	if a1 ~= "TitanCurrenciesMulti" then
	return 
	end
	self:UnregisterEvent("ADDON_LOADED")
	self.ADDON_LOADED = nil

	local name, isHeader, isExpanded, isUnused, isWatched, count, icon, hasWeeklyLimit, currentWeeklyAmount, unknown
	local i = 0
	local CurrencyIndex = 0
	local myicon = "Interface\\Icons\\inv_apexis_draenor.blp"
	local mycheck = "Interface\\Icons\\Inv_Apexis_Draenor"

	self.registry = {
		id = ID,
		menuText = "Titan|cFF007edd "..L["ApexisTitle"].."|r",
		buttonTextFunction = "TitanPanelACButton_GetButtonText",
		tooltipTitle = L["ApexisTitle"],
		tooltipTextFunction = "TitanPanelACButton_GetTooltipText",
		frequency = 2,
		icon = myicon,
		iconWidth = 16,
		category = "Information",
		version = version,
		savedVariables = {
			ShowIcon = 1,
			DisplayOnRightSide = false,
			ShowLabelText = false,
		},
	}
	
	self:SetScript("OnUpdate", function(this, a1)
		elap = elap + a1
		if elap < 1 then return end

		for i = 1, GetCurrencyListSize(), 1 do
			
			name, isHeader, isExpanded, isUnused, isWatched, count, icon, hasWeeklyLimit, currentWeeklyAmount, unknown = GetCurrencyListInfo(i)
			if string.lower(tostring(icon)) == string.lower(mycheck) then
				CurrencyIndex = i
			end
			
		end
		
		name, isHeader, isExpanded, isUnused, isWatched, count, icon, hasWeeklyLimit, currentWeeklyAmount, unknown = GetCurrencyListInfo(CurrencyIndex)

		currencyCount = count
		
		TitanPanelButton_UpdateButton(ID)
		elap = 0
	end)
		
end

----------------------------------------------
function TitanPanelACButton_GetButtonText()
----------------------------------------------
	local currencyCountText
	if not currencyCount then
		currencyCountText = TitanUtils_GetHighlightText("0")
	else	
		currencyCountText = TitanUtils_GetHighlightText(string.format("%.0f", currencyCount) .."")
	end
	return L["ApexisLabel"], currencyCountText
end

-----------------------------------------------
function TitanPanelACButton_GetTooltipText()
-----------------------------------------------
	local texto_tooltip = TitanUtils_GetHighlightText(currencyCount)
	
	if not texto_tooltip then
		texto_tooltip = TitanUtils_GetHighlightText("0")
	end
	
	return L["ApexisDescription"].."\r\r"..L["tooltipCountLabel"]..texto_tooltip
end

----------------------------------------------------
function TitanPanelRightClickMenu_PrepareACMenu()
----------------------------------------------------
	TitanPanelRightClickMenu_AddTitle(TitanPlugins[ID].menuText)
	TitanPanelRightClickMenu_AddToggleIcon(ID)
	TitanPanelRightClickMenu_AddToggleLabelText(ID)
	
info = {};
	info.text = ACE["TITAN_CLOCK_MENU_DISPLAY_ON_RIGHT_SIDE"];
	info.func = TitanPanelACButton_ToggleRightSideDisplay;
	info.checked = TitanGetVar(ID, "DisplayOnRightSide");
	UIDropDownMenu_AddButton(info);
	
	TitanPanelRightClickMenu_AddSpacer();
	TitanPanelRightClickMenu_AddCommand(ACE["TITAN_PANEL_MENU_HIDE"], ID, TITAN_PANEL_MENU_FUNC_HIDE);
end

-----------------------------------------------
function TitanPanelACButton_ToggleRightSideDisplay() -- Right side display
-----------------------------------------------
	TitanToggleVar(ID, "DisplayOnRightSide");
	TitanPanel_InitPanelButtons();
end